package net.javainthebox.heapindicator;

import com.sun.tools.visualvm.application.Application;
import com.sun.tools.visualvm.core.ui.DataSourceView;
import com.sun.tools.visualvm.core.ui.DataSourceViewProvider;
import com.sun.tools.visualvm.core.ui.DataSourceViewsManager;

public class HeapIndicatorProvider 
        extends DataSourceViewProvider<Application> {

    private static DataSourceViewProvider<Application> instance
            =  new HeapIndicatorProvider();

    static void restored() {
        // プラグインの初期化
        DataSourceViewsManager manager = DataSourceViewsManager.sharedInstance();
        manager.addViewProvider(instance, Application.class);
    }

    static void uninstalled() {
        // プラグインのアンインストール
        DataSourceViewsManager manager = DataSourceViewsManager.sharedInstance();
        manager.removeViewProvider(instance);
    }

    @Override
    public boolean supportsViewFor(Application application) {
        // アプリケーションの種類によらず常に表示する
        return true;
    }

    @Override
    public synchronized DataSourceView createView(final Application application) {
        return new HeapIndicator(application);
    }
}
